/* fib-iter.c : calcolo iterativo dell'n-esimo numero di Fibonacci */
#include <stdio.h>
#include <stdlib.h>

int fib(int n)
{
    if (n < 2) {
        return 1;
    } else {
        int i, fn;
        int fn1=1, fn2=1;
        for (i=3; i<=n; i++) {
            fn = fn1 + fn2;
            fn2 = fn1;
            fn1 = fn;
        }
        return fn;
    }
}

/* Questa funzione mostra l'uso dei parametri su riga di comando.
   Per calcolare ad esemipo il decimo numero di Fibonacci,
   occorre dare al prompt di comandi:
   
   ./fib-iter 10

   (supponendo che sia stato compilato questo sorgente
   nell'eseguibile "fib-iter").
*/
int main( int argc, char* argv[] ) 
{
    if ( argc != 2 ) {
        printf("Usage: %s n\n", argv[0]);
        return -1;
    }
    /* La funzione int atoi(const char * s)
       definita in stdlib.h converte la stringa
       s, che deve contenere la rappresentazione di
       un numero, nell'intero corrispondente */
    printf("%d\n", fib(atoi(argv[1])));
    return 0;
}
